#include "xml_browser.h"

void Xml_Browser::set_current_file(QFile *p_file)
{
    current_File = p_file;
    // qDebug() << "chenged to" << p_file->fileName();
}

void Xml_Browser::tree()
{
    main_Menu->clear();
    QAction* pact;
    auto rootList = main_Parser->Get_root_list_slot();
    for(auto it : *rootList)
    {
       pact = main_Menu->addAction(it->text());
       connect(pact, SIGNAL(triggered()), main_Parser, SLOT(Set_current_root_slot()));
    }

}

void Xml_Browser::load_xq()
{
    QString directory = QFileDialog::getOpenFileName(this, "Query File", "", "*.xq");
        if (!directory.isEmpty())
        {
            QFile file(directory);
            if (file.open(QIODevice::ReadOnly))
            {
                QString query = file.readAll();
                file.close();
                query_txt->setText(query);
            }
        }

}

void Xml_Browser::execute()
{
    if(current_File == nullptr)
            return;

    if(!current_File->open(QIODevice::ReadOnly))
            return;

    QFile tech_File("tech_File.xml");

    QString query = query_txt->toPlainText();
    QXmlQuery xml_query(QXmlQuery::XQuery10);

    if (!xml_query.setFocus(current_File))
    {
       qDebug() << "Err1";
    }
    else
    {
       xml_query.setQuery(query);
       if(!xml_query.isValid())
       {
           qDebug() << "Err2";
       }

       tech_File.open(QIODevice::WriteOnly);

       QXmlSerializer ser(xml_query, &tech_File);
       xml_query.evaluateTo(&ser);

       tech_File.close();
       tech_File.open(QIODevice::ReadOnly);


       result_File->open(QIODevice::WriteOnly);
       QTextStream stream(result_File);
       stream << "<?xml version=\"1.0\" encoding=\"windows-1251\"?><catalog>" << tech_File.readAll() << "</catalog>";


      }
        current_File->close();

        result_File->close();
        result_File->open(QIODevice::ReadOnly);

        result_parser->Simple_load_slot(result_File->fileName());

        result_File->close();

}

Xml_Browser::Xml_Browser(QWidget *parent)
    : QMainWindow(parent)
{
    this->setWindowTitle("Xml Browser v1.0");
    // creating mainwindow
    QWidget *main_Window = new QWidget(this);
    QGridLayout *main_layout = new QGridLayout(main_Window);
    //creating file
    result_File = new QFile("result_file.xml");
    result_File->open(QIODevice::WriteOnly);
    //creating main parser
    main_Parser = new xml_parser(this);
    //Creating menu
    QMenu* file_Menu = new QMenu("File", this);
    main_Menu = new QMenu("Opened files", this);
    QMenu* query_Menu = new QMenu("Query", this);
    // setup actions in file menu
    file_Menu->addAction("Open", main_Parser, SLOT(Load_slot()), QKeySequence("CTRL+0"));
    file_Menu->addAction("Drop all", main_Parser, SLOT(Drop_all_slot()),QKeySequence("CTRL+9") );
    file_Menu->addSeparator();
    file_Menu->addAction("Exit", qApp, SLOT(quit()), QKeySequence("SHIFT+CTRL+1"));
    connect(main_Menu, SIGNAL(aboutToShow()), this, SLOT(tree()));
    // setup actions in query menu
    query_Menu->addAction("Execute", this, SLOT(execute()), QKeySequence("CTRL+E"));
    query_Menu->addAction("Load Query", this, SLOT(load_xq()), QKeySequence("CTRL+L"));
    //adding to menubar
    menuBar()->addMenu(file_Menu);
    menuBar()->addMenu(main_Menu);
    menuBar()->addMenu(query_Menu);
    query_document = new QDockWidget("Query", this);
    this->addDockWidget(Qt::DockWidgetArea::RightDockWidgetArea, query_document);
    result_parser = new xml_parser(query_document);
    query_document->setWidget(result_parser);
    query_txt = new QTextEdit(this);
    QPushButton * executeBtn = new QPushButton("Execute");
    QPushButton * loadBtn = new QPushButton("Load");
    connect(executeBtn, SIGNAL(clicked()), this, SLOT(execute()));
    connect(loadBtn, SIGNAL(clicked()), this, SLOT(load_xq()));

    main_layout->addWidget(main_Parser, 0, 0, 4, 5);
    main_layout->addWidget(query_txt, 4, 0, 2, 4);
    main_layout->addWidget(executeBtn, 4, 4, 1, 1);
    main_layout->addWidget(loadBtn, 5, 4, 1, 1);
    main_Window->setLayout(main_layout);

    main_Parser->show();
    resize (800, 600);

    setCentralWidget(main_Window);

    connect(main_Parser, SIGNAL(Send_file(QFile*)), SLOT(set_current_file(QFile*)));





}

Xml_Browser::~Xml_Browser()
{
}

