#ifndef XML_PARSER_H
#define XML_PARSER_H

#include <QTreeView>
#include <QObject>
#include <QWidget>
#include <QtWidgets>
#include <QtXml/QtXml>

class xml_parser : public QTreeView
{
    Q_OBJECT

    private:    //data
        QStandardItemModel* FILE_std_Item_Model;
        QStandardItem *FILE_parent_Item;
        QStandardItem *FILE_tech_Item;
        QList<QStandardItem*> FILE_root_List;
        QStringList FILE_directory_List;

        QMenu* MENU_context_Root_Menu;

        QModelIndex FILE_last_Context_Request;

        QFile* FILE_current_File;

    private:    // private data working methods
        void Node_traverse(const QDomNode& p_dNode, QStandardItem* p_item_ptr);
        void Simple_node_traverse(const QDomNode& p_dNode, QStandardItem* p_item_ptr);

    public:  // constructor
        xml_parser(QWidget* = 0);

    public slots:
        void Load_slot();
        void Load_slot(const QString& f_directory);
        void Simple_load_slot(const QString& f_directory);
        void Drop_all_slot();
        QList<QStandardItem*>* Get_root_list_slot();
        void Set_current_root_slot();
        void Set_current_root_slot(QModelIndex);
        void Context_menu_request_slot(QPoint);
        void Context_menu_reser_slot(QAction*);
        void Drop_single_item_slot(QModelIndex);

    signals:

        void Send_file(QFile*);

};

#endif // XML_PARSER_H
